enum imap_fetchwhat {
    IMAP_END = 0,
    IMAP_UID,			/* int*; no flags */
    IMAP_FLAGS,			/* short*; no flags */
    IMAP_RFC822_SIZE,		/* long*; no flags */
    IMAP_FROMLINE_ADDR,		/* char**; no flags */
    IMAP_FROMLINE_DATE,		/* char**; no flags */
    IMAP_ENVELOPE_FROM,		/* char**; no flags */
    IMAP_LINES,			/* long*; no flags */
    IMAP_HASMIME,		/* long*; no flags */
    IMAP_BODY,			/* char**; no flags */
    IMAP_ENVDATE_STR,		/* char**; no flags */
    IMAP_BODYPEEK_SIZE,		/* char**; int begin, int size */
    IMAP_HEADER			/* char**; char* header_name */
};

int imap_open(void);
void imap_close(void);
int imap_select(char* mailbox);
int imap_deleteuid(int uid);
int imap_append(char* buf);
int imap_msgcount(void);
int imap_expunge(void);

/* imap_fetch(num, IMAP_what, outbuf, opt_flags) */
int imap_fetch(int msgnum, ...);
int imap_fetchuid(int uid, ...);
int imap_setflaguid(int msgnum, long flag);

/* imap_fetchall? */

#ifdef BAD_MAIL_SERVER_UGLY_HACK_XXX
extern int imap_really_expunge_all;
#endif

